<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Session\Session;
use Zeedhi\Framework\DTO\Response\Message;
use \Setforms2\Shared\ORM\DateTime;

use Teknisa\MAN\Utilities\Util;

class AdicionarCampanhaController extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceManager;
    protected $utilService;
    protected $crudService;
    protected $parameterBag;
    
    public function __construct($crudService, $parameterBag, $paramBag, $dataSourceManager, Util $utilService) {
        $this->crudService          = $crudService;
        $this->parameterBag         = $parameterBag;
        $this->dataSourceManager    = $dataSourceManager;
		$this->utilService          = $utilService;
    }
    
    const dataSourceCampanha      = 'vnd17000_adicionarCampanhaCompreGanhe';
    // protected $parameterBagColumns = array('NRORG');
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceCampanha;
        $this->parameterBagColumns = array('NRORG');
        parent::find($request,$response);
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceCampanha;
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $nrPersistedRows = count($persistedRows);
            
        } catch (Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}